/*****************************************************************************
 *                   SEGGER Microcontroller GmbH & Co. KG                    *
 *            Solutions for real time microcontroller applications           *
 *****************************************************************************
 *                                                                           *
 *               (c) 2017 SEGGER Microcontroller GmbH & Co. KG               *
 *                                                                           *
 *           Internet: www.segger.com   Support: support@segger.com          *
 *                                                                           *
 *****************************************************************************/

/*****************************************************************************
 *                         Preprocessor Definitions                          *
 *                         ------------------------                          *
 * VECTORS_IN_RAM                                                            *
 *                                                                           *
 *   If defined, an area of RAM will large enough to store the vector table  *
 *   will be reserved.                                                       *
 *                                                                           *
 *****************************************************************************/

  .syntax unified
  .code 16

  .section .init, "ax"
  .align 0

/*****************************************************************************
 * Default Exception Handlers                                                *
 *****************************************************************************/

  .thumb_func
  .weak NMI_Handler
NMI_Handler:
  b .

  .thumb_func
  .weak HardFault_Handler
HardFault_Handler:
  b .

  .thumb_func
  .weak SVC_Handler
SVC_Handler:
  b .

  .thumb_func
  .weak PendSV_Handler
PendSV_Handler:
  b .

  .thumb_func
  .weak SysTick_Handler
SysTick_Handler:
  b .

  .thumb_func
Dummy_Handler:
  b .

#if defined(__OPTIMIZATION_SMALL)

  .weak WDT_BOD_DriverIRQHandler
  .thumb_set WDT_BOD_DriverIRQHandler,Dummy_Handler

  .weak DMA0_DriverIRQHandler
  .thumb_set DMA0_DriverIRQHandler,Dummy_Handler

  .weak GINT0_DriverIRQHandler
  .thumb_set GINT0_DriverIRQHandler,Dummy_Handler

  .weak GINT1_DriverIRQHandler
  .thumb_set GINT1_DriverIRQHandler,Dummy_Handler

  .weak PIN_INT0_DriverIRQHandler
  .thumb_set PIN_INT0_DriverIRQHandler,Dummy_Handler

  .weak PIN_INT1_DriverIRQHandler
  .thumb_set PIN_INT1_DriverIRQHandler,Dummy_Handler

  .weak PIN_INT2_DriverIRQHandler
  .thumb_set PIN_INT2_DriverIRQHandler,Dummy_Handler

  .weak PIN_INT3_DriverIRQHandler
  .thumb_set PIN_INT3_DriverIRQHandler,Dummy_Handler

  .weak UTICK0_DriverIRQHandler
  .thumb_set UTICK0_DriverIRQHandler,Dummy_Handler

  .weak MRT0_DriverIRQHandler
  .thumb_set MRT0_DriverIRQHandler,Dummy_Handler

  .weak CTIMER0_DriverIRQHandler
  .thumb_set CTIMER0_DriverIRQHandler,Dummy_Handler

  .weak CTIMER1_DriverIRQHandler
  .thumb_set CTIMER1_DriverIRQHandler,Dummy_Handler

  .weak SCT0_DriverIRQHandler
  .thumb_set SCT0_DriverIRQHandler,Dummy_Handler

  .weak CTIMER3_DriverIRQHandler
  .thumb_set CTIMER3_DriverIRQHandler,Dummy_Handler

  .weak FLEXCOMM0_DriverIRQHandler
  .thumb_set FLEXCOMM0_DriverIRQHandler,Dummy_Handler

  .weak FLEXCOMM1_DriverIRQHandler
  .thumb_set FLEXCOMM1_DriverIRQHandler,Dummy_Handler

  .weak FLEXCOMM2_DriverIRQHandler
  .thumb_set FLEXCOMM2_DriverIRQHandler,Dummy_Handler

  .weak FLEXCOMM3_DriverIRQHandler
  .thumb_set FLEXCOMM3_DriverIRQHandler,Dummy_Handler

  .weak FLEXCOMM4_DriverIRQHandler
  .thumb_set FLEXCOMM4_DriverIRQHandler,Dummy_Handler

  .weak FLEXCOMM5_DriverIRQHandler
  .thumb_set FLEXCOMM5_DriverIRQHandler,Dummy_Handler

  .weak FLEXCOMM6_DriverIRQHandler
  .thumb_set FLEXCOMM6_DriverIRQHandler,Dummy_Handler

  .weak FLEXCOMM7_DriverIRQHandler
  .thumb_set FLEXCOMM7_DriverIRQHandler,Dummy_Handler

  .weak ADC0_SEQA_DriverIRQHandler
  .thumb_set ADC0_SEQA_DriverIRQHandler,Dummy_Handler

  .weak ADC0_SEQB_DriverIRQHandler
  .thumb_set ADC0_SEQB_DriverIRQHandler,Dummy_Handler

  .weak ADC0_THCMP_DriverIRQHandler
  .thumb_set ADC0_THCMP_DriverIRQHandler,Dummy_Handler

  .weak DMIC0_DriverIRQHandler
  .thumb_set DMIC0_DriverIRQHandler,Dummy_Handler

  .weak HWVAD0_DriverIRQHandler
  .thumb_set HWVAD0_DriverIRQHandler,Dummy_Handler

  .weak USB0_NEEDCLK_DriverIRQHandler
  .thumb_set USB0_NEEDCLK_DriverIRQHandler,Dummy_Handler

  .weak USB0_DriverIRQHandler
  .thumb_set USB0_DriverIRQHandler,Dummy_Handler

  .weak RTC_DriverIRQHandler
  .thumb_set RTC_DriverIRQHandler,Dummy_Handler

  .weak PIN_INT4_DriverIRQHandler
  .thumb_set PIN_INT4_DriverIRQHandler,Dummy_Handler

  .weak PIN_INT5_DriverIRQHandler
  .thumb_set PIN_INT5_DriverIRQHandler,Dummy_Handler

  .weak PIN_INT6_DriverIRQHandler
  .thumb_set PIN_INT6_DriverIRQHandler,Dummy_Handler

  .weak PIN_INT7_DriverIRQHandler
  .thumb_set PIN_INT7_DriverIRQHandler,Dummy_Handler

  .weak CTIMER2_DriverIRQHandler
  .thumb_set CTIMER2_DriverIRQHandler,Dummy_Handler

  .weak CTIMER4_DriverIRQHandler
  .thumb_set CTIMER4_DriverIRQHandler,Dummy_Handler

  .weak RIT_DriverIRQHandler
  .thumb_set RIT_DriverIRQHandler,Dummy_Handler

  .weak SPIFI0_DriverIRQHandler
  .thumb_set SPIFI0_DriverIRQHandler,Dummy_Handler

  .weak FLEXCOMM8_DriverIRQHandler
  .thumb_set FLEXCOMM8_DriverIRQHandler,Dummy_Handler

  .weak FLEXCOMM9_DriverIRQHandler
  .thumb_set FLEXCOMM9_DriverIRQHandler,Dummy_Handler

  .weak SDIO_DriverIRQHandler
  .thumb_set SDIO_DriverIRQHandler,Dummy_Handler

  .weak CAN0_IRQ0_DriverIRQHandler
  .thumb_set CAN0_IRQ0_DriverIRQHandler,Dummy_Handler

  .weak CAN0_IRQ1_DriverIRQHandler
  .thumb_set CAN0_IRQ1_DriverIRQHandler,Dummy_Handler

  .weak CAN1_IRQ0_DriverIRQHandler
  .thumb_set CAN1_IRQ0_DriverIRQHandler,Dummy_Handler

  .weak CAN1_IRQ1_DriverIRQHandler
  .thumb_set CAN1_IRQ1_DriverIRQHandler,Dummy_Handler

  .weak USB1_DriverIRQHandler
  .thumb_set USB1_DriverIRQHandler,Dummy_Handler

  .weak USB1_NEEDCLK_DriverIRQHandler
  .thumb_set USB1_NEEDCLK_DriverIRQHandler,Dummy_Handler

  .weak ETHERNET_DriverIRQHandler
  .thumb_set ETHERNET_DriverIRQHandler,Dummy_Handler

  .weak ETHERNET_PMT_DriverIRQHandler
  .thumb_set ETHERNET_PMT_DriverIRQHandler,Dummy_Handler

  .weak ETHERNET_MACLP_DriverIRQHandler
  .thumb_set ETHERNET_MACLP_DriverIRQHandler,Dummy_Handler

  .weak EEPROM_DriverIRQHandler
  .thumb_set EEPROM_DriverIRQHandler,Dummy_Handler

  .weak LCD_DriverIRQHandler
  .thumb_set LCD_DriverIRQHandler,Dummy_Handler

  .weak SMARTCARD0_DriverIRQHandler
  .thumb_set SMARTCARD0_DriverIRQHandler,Dummy_Handler

  .weak SMARTCARD1_DriverIRQHandler
  .thumb_set SMARTCARD1_DriverIRQHandler,Dummy_Handler

#else

  .thumb_func
  .weak WDT_BOD_DriverIRQHandler
WDT_BOD_DriverIRQHandler:
  b .

  .thumb_func
  .weak DMA0_DriverIRQHandler
DMA0_DriverIRQHandler:
  b .

  .thumb_func
  .weak GINT0_DriverIRQHandler
GINT0_DriverIRQHandler:
  b .

  .thumb_func
  .weak GINT1_DriverIRQHandler
GINT1_DriverIRQHandler:
  b .

  .thumb_func
  .weak PIN_INT0_DriverIRQHandler
PIN_INT0_DriverIRQHandler:
  b .

  .thumb_func
  .weak PIN_INT1_DriverIRQHandler
PIN_INT1_DriverIRQHandler:
  b .

  .thumb_func
  .weak PIN_INT2_DriverIRQHandler
PIN_INT2_DriverIRQHandler:
  b .

  .thumb_func
  .weak PIN_INT3_DriverIRQHandler
PIN_INT3_DriverIRQHandler:
  b .

  .thumb_func
  .weak UTICK0_DriverIRQHandler
UTICK0_DriverIRQHandler:
  b .

  .thumb_func
  .weak MRT0_DriverIRQHandler
MRT0_DriverIRQHandler:
  b .

  .thumb_func
  .weak CTIMER0_DriverIRQHandler
CTIMER0_DriverIRQHandler:
  b .

  .thumb_func
  .weak CTIMER1_DriverIRQHandler
CTIMER1_DriverIRQHandler:
  b .

  .thumb_func
  .weak SCT0_DriverIRQHandler
SCT0_DriverIRQHandler:
  b .

  .thumb_func
  .weak CTIMER3_DriverIRQHandler
CTIMER3_DriverIRQHandler:
  b .

  .thumb_func
  .weak FLEXCOMM0_DriverIRQHandler
FLEXCOMM0_DriverIRQHandler:
  b .

  .thumb_func
  .weak FLEXCOMM1_DriverIRQHandler
FLEXCOMM1_DriverIRQHandler:
  b .

  .thumb_func
  .weak FLEXCOMM2_DriverIRQHandler
FLEXCOMM2_DriverIRQHandler:
  b .

  .thumb_func
  .weak FLEXCOMM3_DriverIRQHandler
FLEXCOMM3_DriverIRQHandler:
  b .

  .thumb_func
  .weak FLEXCOMM4_DriverIRQHandler
FLEXCOMM4_DriverIRQHandler:
  b .

  .thumb_func
  .weak FLEXCOMM5_DriverIRQHandler
FLEXCOMM5_DriverIRQHandler:
  b .

  .thumb_func
  .weak FLEXCOMM6_DriverIRQHandler
FLEXCOMM6_DriverIRQHandler:
  b .

  .thumb_func
  .weak FLEXCOMM7_DriverIRQHandler
FLEXCOMM7_DriverIRQHandler:
  b .

  .thumb_func
  .weak ADC0_SEQA_DriverIRQHandler
ADC0_SEQA_DriverIRQHandler:
  b .

  .thumb_func
  .weak ADC0_SEQB_DriverIRQHandler
ADC0_SEQB_DriverIRQHandler:
  b .

  .thumb_func
  .weak ADC0_THCMP_DriverIRQHandler
ADC0_THCMP_DriverIRQHandler:
  b .

  .thumb_func
  .weak DMIC0_DriverIRQHandler
DMIC0_DriverIRQHandler:
  b .

  .thumb_func
  .weak HWVAD0_DriverIRQHandler
HWVAD0_DriverIRQHandler:
  b .

  .thumb_func
  .weak USB0_NEEDCLK_DriverIRQHandler
USB0_NEEDCLK_DriverIRQHandler:
  b .

  .thumb_func
  .weak USB0_DriverIRQHandler
USB0_DriverIRQHandler:
  b .

  .thumb_func
  .weak RTC_DriverIRQHandler
RTC_DriverIRQHandler:
  b .

  .thumb_func
  .weak PIN_INT4_DriverIRQHandler
PIN_INT4_DriverIRQHandler:
  b .

  .thumb_func
  .weak PIN_INT5_DriverIRQHandler
PIN_INT5_DriverIRQHandler:
  b .

  .thumb_func
  .weak PIN_INT6_DriverIRQHandler
PIN_INT6_DriverIRQHandler:
  b .

  .thumb_func
  .weak PIN_INT7_DriverIRQHandler
PIN_INT7_DriverIRQHandler:
  b .

  .thumb_func
  .weak CTIMER2_DriverIRQHandler
CTIMER2_DriverIRQHandler:
  b .

  .thumb_func
  .weak CTIMER4_DriverIRQHandler
CTIMER4_DriverIRQHandler:
  b .

  .thumb_func
  .weak RIT_DriverIRQHandler
RIT_DriverIRQHandler:
  b .

  .thumb_func
  .weak SPIFI0_DriverIRQHandler
SPIFI0_DriverIRQHandler:
  b .

  .thumb_func
  .weak FLEXCOMM8_DriverIRQHandler
FLEXCOMM8_DriverIRQHandler:
  b .

  .thumb_func
  .weak FLEXCOMM9_DriverIRQHandler
FLEXCOMM9_DriverIRQHandler:
  b .

  .thumb_func
  .weak SDIO_DriverIRQHandler
SDIO_DriverIRQHandler:
  b .

  .thumb_func
  .weak CAN0_IRQ0_DriverIRQHandler
CAN0_IRQ0_DriverIRQHandler:
  b .

  .thumb_func
  .weak CAN0_IRQ1_DriverIRQHandler
CAN0_IRQ1_DriverIRQHandler:
  b .

  .thumb_func
  .weak CAN1_IRQ0_DriverIRQHandler
CAN1_IRQ0_DriverIRQHandler:
  b .

  .thumb_func
  .weak CAN1_IRQ1_DriverIRQHandler
CAN1_IRQ1_DriverIRQHandler:
  b .

  .thumb_func
  .weak USB1_DriverIRQHandler
USB1_DriverIRQHandler:
  b .

  .thumb_func
  .weak USB1_NEEDCLK_DriverIRQHandler
USB1_NEEDCLK_DriverIRQHandler:
  b .

  .thumb_func
  .weak ETHERNET_DriverIRQHandler
ETHERNET_DriverIRQHandler:
  b .

  .thumb_func
  .weak ETHERNET_PMT_DriverIRQHandler
ETHERNET_PMT_DriverIRQHandler:
  b .

  .thumb_func
  .weak ETHERNET_MACLP_DriverIRQHandler
ETHERNET_MACLP_DriverIRQHandler:
  b .

  .thumb_func
  .weak EEPROM_DriverIRQHandler
EEPROM_DriverIRQHandler:
  b .

  .thumb_func
  .weak LCD_DriverIRQHandler
LCD_DriverIRQHandler:
  b .

  .thumb_func
  .weak SMARTCARD0_DriverIRQHandler
SMARTCARD0_DriverIRQHandler:
  b .

  .thumb_func
  .weak SMARTCARD1_DriverIRQHandler
SMARTCARD1_DriverIRQHandler:
  b .

#endif

/*****************************************************************************
 * Vector Table                                                              *
 *****************************************************************************/

  .section .vectors, "ax"
  .align 0
  .global _vectors
  .extern __stack_end__
  .extern Reset_Handler

_vectors:
  .word __stack_end__
  .word Reset_Handler
  .word NMI_Handler
  .word HardFault_Handler
  .word 0 /* MemManage_Handler */
  .word 0 /* BusFault_Handler */
  .word 0 /* UsageFault_Handler */
  .word 0 /* Reserved */
  .word 0 /* Reserved */
  .word 0xEDDC94BD  /* Enhanced image marker, set to 0x0 for legacy boot */
  .word 0x160       /* Pointer to enhanced boot block, set to 0x0 for legacy boot */
  .word SVC_Handler
  .word 0 /* Reserved */
  .word 0 /* Reserved */
  .word PendSV_Handler
  .word SysTick_Handler
  .word WDT_BOD_DriverIRQHandler
  .word DMA0_DriverIRQHandler
  .word GINT0_DriverIRQHandler
  .word GINT1_DriverIRQHandler
  .word PIN_INT0_DriverIRQHandler
  .word PIN_INT1_DriverIRQHandler
  .word PIN_INT2_DriverIRQHandler
  .word PIN_INT3_DriverIRQHandler
  .word UTICK0_DriverIRQHandler
  .word MRT0_DriverIRQHandler
  .word CTIMER0_DriverIRQHandler
  .word CTIMER1_DriverIRQHandler
  .word SCT0_DriverIRQHandler
  .word CTIMER3_DriverIRQHandler
  .word FLEXCOMM0_DriverIRQHandler
  .word FLEXCOMM1_DriverIRQHandler
  .word FLEXCOMM2_DriverIRQHandler
  .word FLEXCOMM3_DriverIRQHandler
  .word FLEXCOMM4_DriverIRQHandler
  .word FLEXCOMM5_DriverIRQHandler
  .word FLEXCOMM6_DriverIRQHandler
  .word FLEXCOMM7_DriverIRQHandler
  .word ADC0_SEQA_DriverIRQHandler
  .word ADC0_SEQB_DriverIRQHandler
  .word ADC0_THCMP_DriverIRQHandler
  .word DMIC0_DriverIRQHandler
  .word HWVAD0_DriverIRQHandler
  .word USB0_NEEDCLK_DriverIRQHandler
  .word USB0_DriverIRQHandler
  .word RTC_DriverIRQHandler
  .word Dummy_Handler /* Reserved */
  .word Dummy_Handler /* Reserved */
  .word PIN_INT4_DriverIRQHandler
  .word PIN_INT5_DriverIRQHandler
  .word PIN_INT6_DriverIRQHandler
  .word PIN_INT7_DriverIRQHandler
  .word CTIMER2_DriverIRQHandler
  .word CTIMER4_DriverIRQHandler
  .word RIT_DriverIRQHandler
  .word SPIFI0_DriverIRQHandler
  .word FLEXCOMM8_DriverIRQHandler
  .word FLEXCOMM9_DriverIRQHandler
  .word SDIO_DriverIRQHandler
  .word CAN0_IRQ0_DriverIRQHandler
  .word CAN0_IRQ1_DriverIRQHandler
  .word CAN1_IRQ0_DriverIRQHandler
  .word CAN1_IRQ1_DriverIRQHandler
  .word USB1_DriverIRQHandler
  .word USB1_NEEDCLK_DriverIRQHandler
  .word ETHERNET_DriverIRQHandler
  .word ETHERNET_PMT_DriverIRQHandler
  .word ETHERNET_MACLP_DriverIRQHandler
  .word EEPROM_DriverIRQHandler
  .word LCD_DriverIRQHandler
  .word Dummy_Handler /* Reserved */
  .word SMARTCARD0_DriverIRQHandler
  .word SMARTCARD1_DriverIRQHandler
_vectors_end:

  .long   0                                               /* Reserved */
  .long   0                                               /* Reserved */    
  .long   0                                               /* Reserved */
  .long   0                                               /* Reserved */
  .long   0                                               /* Reserved */
  .long   0                                               /* Reserved */
  .long   0                                               /* Reserved */
  .long   0                                               /* Reserved */
  .long   0                                               /* Reserved */
  .long   0                                               /* Reserved */
  .long   0                                               /* Reserved */
  .long   0                                               /* Reserved */
  .long   0                                               /* Reserved */
  .long   0                                               /* Reserved */
  .long   0                                               /* Reserved */

#ifndef IMG_BAUDRATE
#define IMG_BAUDRATE 0
#endif

#ifndef __IMAGE_SIZE
#define __IMAGE_SIZE  0x30000
#endif

#ifndef __IMAGE_CRC
#define __IMAGE_CRC   0
#endif

__image_header:
    .long   0xFEEDA5A5                                      /* (0x00, 0x160) Header Marker */
    #ifdef XIP_IMAGE
          #ifdef ADD_CRC
          .long   0x2                                       /* (0x04) Image Type */
          #else
          .long   0x3                                       /* (0x04) Image Type */
          #endif
    #else
          #ifdef ADD_CRC
          .long   0x0                                       /* (0x04) Image Type */
          #else
          .long   0x1                                       /* (0x04) Image Type */
          #endif    
    #endif
    
    #ifdef XIP_IMAGE
          .long   0x10000000                                /* (0x08) Load_address */
    #else
          .long   0x00000000                                /* (0x08) Load_address */
    #endif
    #ifdef ADD_CRC
          .long   __IMAGE_SIZE                              /* (0x0C) load_length */
          .long   __IMAGE_CRC                               /* (0x10) CRC value (only applicable to NON Non-secure images) */
    #else
          .long   0                                         /* (0x0C) load_length */
          .long   0                                         /* (0x10) CRC value (only applicable to NON Non-secure images) */
    #endif
    
    .long   0                                               /* (0x14) Version (only applicable to DUAL_ENH image type */
    .long   0                                               /* (0x18) EMC static memory configuration settings, required for EMC boot */
    .long   IMG_BAUDRATE                                    /* image baudrate */
    .long   0                                               /* Reserved */
    .long   0xEDDC94BD                                      /* (0x24) Image_marker */
    .long   0                                               /* (0x28) SBZ */
    .long   0                                               /* (0x2C) reserved */
     #ifdef W25Q128JVFM
     /* SPI Descriptor - W25Q128JVFM */
    .long   0x00000000                                      /* 0xFFFFFFFF to default 1-bit SPI mode  ;DevStrAdr */
    .long   0x001870EF                                      /* mfgId + extCount */
    .long   0x00000000                                      /* extid 0-3 */
    .long   0x00000000                                      /* extid 4-7 */
    .long   0x0001001D                                      /* caps */
    .long   0x00000100                                      /* Blks + RESV1 */
    .long   0x00010000                                      /* blkSize */
    .long   0x00000000                                      /* subBlks + subBlkSize */
    .long   0x00000100                                      /* pageSize + RESV2 */
    .long   0x00003F00                                      /* maxReadSize */
    .long   0x68506850                                      /* maxClkRate,maxReadRate,maxHSReadRate,maxProgramRate */
    .long   0x04030050                                      /* maxHSProgramRate,initDeInitFxId,clearStatusFxId,getStatusFxId, */
    .long   0x14110D09                                      /* setStatusFxId,setOptionsFxId,getReadCmdFxId,getWriteCmdFxId */
    #endif 

     #ifdef MXL12835F
     /* SPI Descriptor - MXL12835F */
    .long   0x00000000                                      /* 0xFFFFFFFF to default 1-bit SPI mode  ;DevStrAdr */
    .long   0x001820C2                                      /* mfgId + extCount */
    .long   0x00000000                                      /* extid 0-3 */
    .long   0x00000000                                      /* extid 4-7 */
    .long   0x0001001D                                      /* caps */
    .long   0x00000100                                      /* Blks + RESV1 */
    .long   0x00010000                                      /* blkSize */
    .long   0x00000000                                      /* subBlks + subBlkSize */
    .long   0x00000100                                      /* pageSize + RESV2 */
    .long   0x00003F00                                      /* maxReadSize */
    .long   0x68506850                                      /* maxClkRate,maxReadRate,maxHSReadRate,maxProgramRate */
    .long   0x06030050                                      /* maxHSProgramRate,initDeInitFxId,clearStatusFxId,getStatusFxId */
    .long   0x14110F0B                                      /* setStatusFxId,setOptionsFxId,getReadCmdFxId,getWriteCmdFxId */
    #endif 

#ifdef VECTORS_IN_RAM
  .section .vectors_ram, "ax"
  .align 0
  .global _vectors_ram

_vectors_ram:
  .space _vectors_end - _vectors, 0
#endif
